/******************************************************************************
 *   Copyright (C) 2009 by Oliver Bock                                        *
 *   oliver.bock[AT]aei.mpg.de                                                *
 *                                                                            *
 *   This file is part of PulsatingScience.                                   *
 *                                                                            *
 *   PulsatingScience is free software: you can redistribute it and/or modify *
 *   it under the terms of the GNU General Public License as published        *
 *   by the Free Software Foundation, version 3 of the License.               *
 *                                                                            *
 *   PulsatingScience is distributed in the hope that it will be useful,      *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             *
 *   GNU General Public License for more details.                             *
 *                                                                            *
 *   You should have received a copy of the GNU General Public License        *
 *   along with PulsatingScience. If not, see <http://www.gnu.org/licenses/>. *
 *                                                                            *
 ******************************************************************************/

#ifndef PULSESCOPEWIDGET_H_
#define PULSESCOPEWIDGET_H_

#include <cmath>

#include <QGraphicsView>
#include <QGraphicsScene>
#include <QGLContext>
#include <QGraphicsPathItem>
#include <QGraphicsLineItem>


class PulseScopeWidget : public QGraphicsView
{
	Q_OBJECT

public:
	PulseScopeWidget(QWidget *parent = 0);
	virtual ~PulseScopeWidget();

	void resizeEvent(QResizeEvent *event);

public slots:
	void drawCurve(const QVector<float>& vector);
	void markerStep(float stepSize);
	void markerReset();

private:
	QGraphicsScene m_scene;
	QVector<float> m_data;
	QGraphicsPathItem *m_path;
	QGraphicsLineItem *m_marker;

	int m_scopeSizeH;
	float m_scopeSizeV;
};

#endif /* PULSESCOPEWIDGET_H_ */
